#include "Board.h"
#include "FKUT/Misc.h"

Board::Board(void)
{
	// [6/5]Ֆʔz̏֐
	initBoard();
	// Ֆʍ쐬
	setupBoard();
}

Board::~Board(void)
{
	// {͐΂̉ȂƂȂcc
}

// Ֆʂ̏
void Board::initBoard(void)
{
	// z̏l-1(uĂȂ)ŏ
	for(int i = 0; i < BOARD_WIDTH; ++i) {
		for(int j = 0; j < BOARD_WIDTH; ++j) {
			cellInfo[i][j].index = -1;
			cellInfo[i][j].color = ST_DEFAULT;
		}
	}
}

// V[ւ̕\
void Board::entry(fk_Scene *argScene)
{
	argScene->entryModel(&blockModel);
	argScene->entryModel(&gridModel);

	return;
}

// V[̏
void Board::remove(fk_Scene *argScene)
{
	argScene->removeModel(&blockModel);
	argScene->removeModel(&gridModel);

	return;
}

// [6/19]Ֆʂ̍\z(萔Ή)
void Board::setupBoard(void)
{
	// ̂̐ݒ
	block.makeBlock(10.0 + BOARD_WIDTH*10.0, 5.0, 10.0 + BOARD_WIDTH*10.0),
	blockModel.setShape(&block);
	blockModel.setMaterial(Green);
	blockModel.glTranslate(0.0, -2.75, 0.0);

	// Obh
	fk_Vector	posA, posB;
	for(int i = 0; i < BOARD_WIDTH+1; ++i) {
		posA.set(-10.0*BOARD_WIDTH/2.0 + i*10.0, 0.0, -10.0*BOARD_WIDTH/2.0);
		posB.set(-10.0*BOARD_WIDTH/2.0 + i*10.0, 0.0,  10.0*BOARD_WIDTH/2.0);
		grid.pushLine(posA, posB);
		posA.set(-10.0*BOARD_WIDTH/2.0, 0.0, -10.0*BOARD_WIDTH/2.0 + i*10.0);
		posB.set( 10.0*BOARD_WIDTH/2.0, 0.0, -10.0*BOARD_WIDTH/2.0 + i*10.0);
		grid.pushLine(posA, posB);
	}
	gridModel.setShape(&grid);
	gridModel.setLineColor(0.0, 0.0, 0.0);
	gridModel.setWidth(2.0);

	return;
}

int Board::checkCell(const fk_Vector &argPos, fk_Vector *argAdjustPos, StoneColor argColor)
{
	// ␳
	int tmpX = (int)argPos.x;
	int tmpZ = (int)argPos.z;
	if(tmpX > 0) {
		argAdjustPos->x = tmpX - (tmpX % 10) + 5;
	} else {
		argAdjustPos->x = tmpX - (tmpX % 10) - 5;
	}
	if(tmpZ > 0) {
		argAdjustPos->z = tmpZ - (tmpZ % 10) + 5;
	} else {
		argAdjustPos->z = tmpZ - (tmpZ % 10) - 5;
	}
	argAdjustPos->y = 0.0;

	// 3Wlz̍Wl𓾂
	CellPosition	pos = calcID(*argAdjustPos);
	if(pos.x == -1) {
		return CR_OUT_RANGE;
	}

	// ɒuĂ邩`FbN
	if(cellInfo[pos.x][pos.y].index >= 0) {
		return cellInfo[pos.x][pos.y].index;
	}

	// uȂu邱Ƃʒm
	if(checkAround(pos, argColor) == true) {
		return CR_SUCCESS;
	}

	return CR_FAILED;
}

// ̐΂ӂɂ邩𒲂ׂ֐
bool Board::checkAround(const CellPosition &argPos, StoneColor argColor)
{
	// ̐F𓾂
	StoneColor	oppositeColor = Stone::opposite(argColor);

	cout << "Check start: my color " << argColor << ", opposite color " << oppositeColor << endl;

	// ̐FאڂĂlߍރXg
	list<CellPosition>	vecList;

	// Ӄ`FbN
	CellPosition		aroundPos;
	cout << "Around Check:" << endl; 
	for(int i = -1; i <= 1; ++i) {
		aroundPos.x = argPos.x + i;
		if(aroundPos.x < 0 || aroundPos.x > BOARD_WIDTH-1) continue;
		for(int j = -1; j <= 1; ++j) {
			if(i == 0 && j == 0) continue;
			aroundPos.y = argPos.y + j;
			if(aroundPos.y < 0 || aroundPos.y > BOARD_WIDTH-1) continue;
			cout << aroundPos.x << "," << aroundPos.y;
			if(cellInfo[aroundPos.x][aroundPos.y].color == oppositeColor) {
				vecList.push_back(CellPosition(i, j));
				cout << ": OK" << endl;
			} else {
				cout << ": NG" << endl;
			}
		}
	}

	// ӂɑ̐΂炻̎_ŏI
	if(vecList.size() == 0) return false;

	// ЂԂ̃Xg(totalŏIIȃXgAtmp͈ꎞIȋLp)
	list<CellPosition>	totalRevList, tmpRevList;

	// XgCe[^ŎQƂ(Ce[^̌^typedefĎgƕ֗)
	typedef list<CellPosition>::iterator	ListIte;

	// ̐F̐Ɏ̐F邩`FbN
	for(ListIte ite = vecList.begin(); ite != vecList.end(); ++ite) {
		// ׂ_NbNZɃZbg
		CellPosition	vCheck = argPos;
		// Ce[^͊i[vf̃|C^\̂->Ńo
		cout << "Vec: " << ite->x << "," << ite->y << endl;
		// ΂uĂȂAʒ[A̐FÂꂩŔ郋[v
		while(true) {
			// Xgɋlߍ܂Ă炷
			vCheck = vCheck + (*ite);
			//vCheck.x += ite->x;
			//vCheck.y += ite->y;
			cout << vCheck.x << "," << vCheck.y;
			// Ֆʓ
			if(vCheck.isValid()) {
				if(cellInfo[vCheck.x][vCheck.y].color == argColor) {
					// ̐F̂OK
					cout << ": my color -> OK" << endl;
					// tmpXgɓ˂łЂԂtotalɈړ
					for(ListIte tmpIt = tmpRevList.begin();
						tmpIt != tmpRevList.end(); ++tmpIt)
					{
						// Ce[^*tƎ̂o
						totalRevList.push_back(*tmpIt);
					}
					tmpRevList.clear();	// NAbreak
					break;
				} else if(cellInfo[vCheck.x][vCheck.y].color == oppositeColor) {
					// ܂̐FȂ̂ŒTs
					cout << ": opposite color -> continue...";
					tmpRevList.push_back(vCheck);	// tmpXgɂЂԂ邩ȂWǉ
				} else {
					// ΂uĂȂ̂NG
					cout << ": no stone -> NG" << endl;
					tmpRevList.clear();	// NAbreak
					break;
				}
			} else {
				// ՖʊOɏôNG
				cout << ": out of range -> NG" << endl;
				tmpRevList.clear();		// NAbreak
				break;
			}
		}
	}

	// ЂԂ΂1ȏ゠
	if(totalRevList.size() != 0) {
		for(ListIte ite = totalRevList.begin(); ite != totalRevList.end(); ++ite) {
			int idx = cellInfo[ite->x][ite->y].index;
			// ΂ɂЂԂw
			stoneArray[idx]->reverse();
			// z̏XV
			setStoneID(calcID(stoneArray[idx]->getPosition()), idx);
		}

		return true;
	}

	return false;
}

// u΂ID(z̓Y)(FwȗŔ])
void Board::setStoneID(const CellPosition &argPos, int argID, StoneColor argColor)
{
	cellInfo[argPos.x][argPos.y].index = argID;
	if(argColor == ST_DEFAULT) {
		cellInfo[argPos.x][argPos.y].color = Stone::opposite(cellInfo[argPos.x][argPos.y].color);
	} else {
		cellInfo[argPos.x][argPos.y].color = argColor;
	}

	return;
}

// [6/19]3Wlz̍Wlɕϊ(萔Ή)
CellPosition Board::calcID(const fk_Vector &argPos)
{
	CellPosition	pos;
	pos.x = (int)(argPos.x + (BOARD_WIDTH-1)*5)/10;
	pos.y = (int)(argPos.z + (BOARD_WIDTH-1)*5)/10;

	// ͈͊O`FbN
	if(pos.x < 0 || pos.x > BOARD_WIDTH-1 || pos.y < 0 || pos.y > BOARD_WIDTH-1) {
		pos.x = pos.y = -1;
	}

	return pos;
}

// ΂u
int Board::makeStone(const fk_Vector &argPos, StoneColor argColor, fk_Scene *argScene)
{
	stoneArray.push_back(new Stone(argColor));
	stoneArray.back()->setPosition(argPos);
	stoneArray.back()->entry(argScene);

	// Ֆʃf[^ɉԖڂ̐΂ûZbg
	setStoneID(calcID(argPos), stoneArray.size()-1, stoneArray.back()->getColor());

	return (int)stoneArray.size();
}

// ΂̃NA
void Board::clearStone(fk_Scene *argScene)
{
	int num = stoneArray.size();
	for(int i = 0; i < num; ++i) {
		stoneArray[i]->remove(argScene);
		delete stoneArray[i];
	}
	stoneArray.clear();
	initBoard();

	return;
}

// [6/19z]Z[u̎
void Board::saveState(ofstream &out_file)
{
	// ܂̓wb_sƁA΂̌o
	out_file << "[BOARD INFO]" << endl;
	int num = stoneArray.size();
	out_file << num << endl;
	// [v񂵂ĐF,x,y,z̏ɏo
	for(int i = 0; i < num; ++i) {
		fk_Vector tmpPos = stoneArray[i]->getPosition();
		out_file << stoneArray[i]->getColor() << "," << tmpPos.x << "," << tmpPos.y << "," << tmpPos.z << endl;
	}

	return;
}

// [6/19z][h̎
bool Board::loadState(ifstream &in_file, fk_Scene *argScene)
{
	string			str;
	vector<string>	strSplit;
	int				num = 0;

	// ΂̌擾
	if(getline(in_file, str)) {
		num = atoi(str.c_str());
	} else {
		return false;
	}

	// ՖʂNA
	clearStone(argScene);

	// Ԃ񃋁[vAĔzuĂ
	for(int i = 0; i < num; ++i) {
		if(getline(in_file, str)) {
			// J}؂ŕ
			strSplit = fk_StrSplit(str, ",");
			// ڂ4ȏȂ珈AłȂ΃G[
			if(strSplit.size() >= 4) {
				// 3ZqŐF̒萔
				StoneColor	color = (atoi(strSplit[0].c_str()) == 0) ? ST_BLACK : ST_WHITE;
				// ʒuWfk_Vectorɕ
				fk_Vector	pos(atof(strSplit[1].c_str()), atof(strSplit[2].c_str()), atof(strSplit[3].c_str()));
				// ΂̔zu(Q[vCƓ֐g񂷂̂|Cg)
				makeStone(pos, color, argScene);
			} else {
				return false;
			}
		} else {
			return false;
		}
	}

	return true;
}

// [6/19z]
void Board::update(StoneColor argNowTurn)
{
	// [6/5]]Aj[V̂߁ASĂ̐΂̏Ԃ𖈃t[XV
	int num = stoneArray.size();
	for(int i = 0; i < num; ++i) {
		stoneArray[i]->update(argNowTurn);
	}
}
