#ifndef __BOARD_H__
#define __BOARD_H__

#include <FK/FK.h>
#include "Stone.h"

// [6/19]Ֆʂ̃TCYォς悤ɒ萔
const int BOARD_WIDTH = 8;

// [6/19]2zł̍Wld\
struct CellPosition {
	int	x, y;

	// RXgN^(-1ŏ)
	CellPosition(int x = -1, int y = -1)
	{
		this->x = x, this->y = y;
	};

	// Ֆʂ̒ɍWl܂Ă邩𒲂ׂ֐
	bool isValid(void)
	{
		if(x >= 0 && x < BOARD_WIDTH && y >= 0 && y < BOARD_WIDTH) return true;
		
		return false;
	};

	// ŖpFZqĒ`(Iy[^I[o[[h)
	friend CellPosition operator+(const CellPosition &l, const CellPosition &r)
	{
		return CellPosition(l.x + r.x, l.y + r.y);
	};
};

// [6/19]2zŎ΂̗vfԍƐFɊg
struct CellData {
	int			index;	// ̃ZɒuĂ΂̗vfԍ
	StoneColor	color;	// ̃Z̒uĂF
};

// [6/19]NbŇʂ`
enum ClickResult {
	CR_FAILED = -3,		// uȂ
	CR_OUT_RANGE = -2,	// ՖʊO
	CR_SUCCESS = -1		// u
	// 0ȏF̗vfԍ̐΂uĂ
};

// IZ̔Ֆʂ\NX
class Board {
public:
	// RXgN^ƃfXgN^
	Board(void);
	virtual ~Board(void);
	
	// [6/5]Ֆʃf[^
	void	initBoard(void);
	// Ֆʂ`鏈
	void	setupBoard(void);
	// \E\֐ĊO琧ł悤
	void	entry(fk_Scene *scene);
	void	remove(fk_Scene *scene);

	// [6/19]t[̍XV(΂̍XVĂяop)
	void	update(StoneColor nowTurn);
	
	// NbNꂽʒu1ɓnA␳ʂ2ɕԂB
	// [6/19]̎Ԃ̐F3ɓnB
	// ܂ԒlƂāAɒuȂ-1A͈͊OȂ-2A
	// ɐ΂uĂꍇ̗͂vfԍԂB
	int		checkCell(const fk_Vector &pos, fk_Vector *adjustPos, StoneColor color);
	
	// [6/19z]΂w肵ꏊɐ鏈(F𖾎IɎw肷悤ɕύX)
	int		makeStone(const fk_Vector &pos, StoneColor color, fk_Scene *scene);
	// [6/19z]΂֐
	void	clearStone(fk_Scene *scene);

	// [6/19]Ώ̏o
	void	saveState(ofstream &out_file);	
	// [6/19]Ώ̓ǂݍ
	bool	loadState(ifstream &in_file, fk_Scene *scene);	

	// [6/19]3Wlz̍Wlɕϊ(萔Ή)
	CellPosition	calcID(const fk_Vector &pos);

protected:
	// Ֆʕ\po
	fk_Block		block;
	fk_Model		blockModel;
	fk_Line			grid;
	fk_Model		gridModel;
	// [6/19]΂Ɏ邱Ƃɂ
	vector<Stone *>	stoneArray;
	// Ֆʏ̃f[^2zŎ
	CellData		cellInfo[BOARD_WIDTH][BOARD_WIDTH];

	// [6/19]ẑƓɊOGȂĂ֐̂
	// protectedɕύX(zx[X̍WlɕύX)

	// u΂ID(z̓Y)(FwȗŔ])
	void	setStoneID(const CellPosition &pos, int id, StoneColor color = ST_DEFAULT);
	// ̐΂ӂɂ邩𒲂ׂ֐
	bool	checkAround(const CellPosition &pos, StoneColor color);
};


#endif //__BOARD_H__
